<template>
  <Menu
    :items="items"
    :is-vertical="isVertical"
  >
    <template
      v-if="asset"
      #asset
    >
      <FormSelect
        v-model="asset"
        :placeholder="assetLabel"
        :data="availableAssets"
        is-autocomplete
        height="100%"
        :width="!isDesktop ? '100%' : '90px'"
        :query-timeout="0"
        @query="fetchAssets"
      />
    </template>
    <template
      v-if="language"
      #language
    >
      <FormSelect
        v-model="language"
        :placeholder="languageLabel"
        :data="availableLanguages"
        is-autocomplete
        height="100%"
        :width="!isDesktop ? '100%' : '120px'"
        :query-timeout="0"
        @query="fetchLanguages"
      />
    </template>
    <template
      #search
    >
      <FormInput
        v-model="searchQuery"
        :is-compact="!isSearchActive"
        :width="isDesktop ? (isSearchActive ? '150px' : '58px') : '100%'"
        :state="isSearchActive ? 'outline' : undefined"
        height="100%"
        @blur="isSearchActive = false"
        @focus="isSearchActive = true"
      >
        <Icon
          slot="after"
          type="magnifier"
        />
      </FormInput>
      <Button
        v-if="!isDesktop"
        :size="isDesktop ? 'sm' : 'lg'"
        height="100%"
        @click="onSettingsButtonClick"
      >
        <Icon type="gear" />
      </Button>
    </template>
    <template
      v-if="isDesktop"
      #settings
    >
      <Button
        size="sm"
        height="100%"
        @click="onSettingsButtonClick"
      >
        <Icon type="gear" />
      </Button>
    </template>
  </Menu>
</template>

<script>
import Menu from '../../components/menu/Menu';
import FormSelect from '../../components/form/select/Select';
import FormInput from '../../components/form/input/Input';
import Icon from '../../components/icon/Icon';
import Button from '../../components/button/Button';
import bpMixin from '../../mixins/bpMixin';

export default {
  name: 'SideContainer',
  components: {
    Button,
    Icon,
    FormInput,
    FormSelect,
    Menu,
  },
  mixins: [bpMixin],
  props: {
    isVertical: Boolean,
  },
  data() {
    return {
      items: ['asset', 'language', 'search', 'settings'].map(
        (key) => ({ key }),
      ),

      assetsQuery: '',
      languagesQuery: '',
      isSearchActive: false,
      searchQuery: '',
    };
  },
  computed: {
    asset: {
      get() {
        return this.$store.getters['common/asset'];
      },
      set(value) {
        this.assetsQuery = '';
        this.$store.commit('common/setAsset', value);
      },
    },
    assetLabel() {
      return this.asset
        && this.$store.getters['references/assets'].find(({ id }) => id === this.asset).symbol;
    },
    availableAssets() {
      return this.$store.getters['references/assets'].map(({ id: key, symbol: text, name: hint }) => ({
        key,
        text,
        hint,
      })).filter(
        ({ key, text, hint }) => [key, text, hint].filter(Boolean).filter(
          (i) => i.toLowerCase().indexOf(this.assetsQuery.toLowerCase()) > -1,
        ).length > 0,
      );
    },
    language: {
      get() {
        return this.$store.getters['common/language'];
      },
      set(value) {
        this.languagesQuery = '';
        this.$store.commit('common/setLanguage', value);
      },
    },
    languageLabel() {
      return this.language
        && this.$store.getters['references/languages'].find(({ key }) => key === this.language).text;
    },
    availableLanguages() {
      return this.$store.getters['references/languages'].filter(
        ({ key, text, hint }) => [key, text, hint].filter(Boolean).filter(
          (i) => i.toLowerCase().indexOf(this.languagesQuery.toLowerCase()) > -1,
        ).length > 0,
      );
    },
  },
  methods: {
    fetchAssets(query) {
      this.assetsQuery = query;
    },
    fetchLanguages(query) {
      this.languagesQuery = query;
    },
    onSettingsButtonClick() {
      this.$store.commit('common/showSettings');
    },
  },
};
</script>
